Subject: Re: bug#58877: 29.0.50; [PATCH] When killing Emacs from a client frame with no other frames, Emacs shows a useless error prompt

From: Eli Zaretskii <[email-masked]>
Date: Sat, 26 Nov 2022 22:35:57 +0200

> Date: Sat, 26 Nov 2022 12:17:59 -0800
> Cc: [email-masked]
> From: Jim Porter <[email-masked]>
> 
> >      Client output: *ERROR*: Not using an ASCII terminal now; cannot make a new ASCII frame
> > 
> >                     Process d:/gnu/git/emacs/trunk/lib-src/emacsclient exited abnormally with code 1
> > 
> > This is because emacsclient on Windows cannot create new terminal frames,
> > only new GUI frames, unless Emacs was started as "emacs -nw".
> > 
> > Why do these tests need TTY frames?
> 
> The test code just calls "emacsclient -c", and they should be happy with 
> any kind of frame, TTY or GUI. I guess that by running in batch mode, 
> Emacs will try to create TTY frames, but that fails on MS Windows?

I guess.  And I'm not prepared to spend time trying to make emacsclient work
with a batch-mode server on MS-Windows.

> > Btw, with the above changes, only 3 tests fail:
> > 
> >    3 unexpected results:
> >       FAILED  server-tests/emacsclient/create-frame
> >       FAILED  server-tests/server-force-stop/keeps-frames
> >       FAILED  server-tests/server-start/stop-prompt-with-client
> > 
> > So this is progress, thanks.
> 
> All these tests involve creating client frames, so that makes sense. I'm 
> not sure how to coax Emacs into creating GUI frames on MS Windows for 
> these tests though. Still, I don't think these failures are a sign of 
> anything broken exactly; it's just the combination of MS Windows' 
> limitations with trying to create frames in an Emacs batch session.
> 
> Unless you have an idea for how to fix that (I've got no clue, 
> unfortunately), how about just skipping these tests on MS Windows, with 
> a comment explaining what the limitation is?

Fine with me, thanks.